[PATCH nft 6/6] tools: add "tools/check-tree.sh" script to check consistency of nft dumps

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

 



The script performs some checks on the source tree, and fails if
any problems are found.

Currently it only checks for the dumps files, but it shall be extended
to perform various consistency checks of the source tree.

This script was already successful at finding issues with the dumps.
Running it helps to make sure we don't make mistakes.

Later it should also integrate with `make check` and/or be called
from CI.

Signed-off-by: Thomas Haller <thaller@xxxxxxxxxx>
---
 tools/check-tree.sh | 91 +++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 91 insertions(+)
 create mode 100755 tools/check-tree.sh

diff --git a/tools/check-tree.sh b/tools/check-tree.sh
new file mode 100755
index 000000000000..ede3e6998ecc
--- /dev/null
+++ b/tools/check-tree.sh
@@ -0,0 +1,91 @@
+#!/bin/bash -e
+
+# Preform various consistency checks of the source tree.
+
+die() {
+	printf '%s\n' "$*"
+	exit 1
+}
+
+array_contains() {
+	local needle="$1"
+	local a
+	shift
+	for a; do
+		[ "$a" = "$needle" ] && return 0
+	done
+	return 1
+}
+
+cd "$(dirname "$0")/.."
+
+EXIT_CODE=0
+
+##############################################################################
+
+check_shell_dumps() {
+	local TEST="$1"
+	local base="$(basename "$TEST")"
+	local dir="$(dirname "$TEST")"
+	local has_nft=0
+	local has_nodump=0
+	local nft_name
+	local nodump_name
+
+	if [ ! -d "$dir/dumps/" ] ; then
+		echo "\"$TEST\" has no \"$dir/dumps/\" directory"
+		EXIT_CODE=1
+		return 0
+	fi
+
+	nft_name="$dir/dumps/$base.nft"
+	nodump_name="$dir/dumps/$base.nodump"
+
+	[ -f "$nft_name" ] && has_nft=1
+	[ -f "$nodump_name" ] && has_nodump=1
+
+	if [ "$has_nft" != 1 -a "$has_nodump" != 1 ] ; then
+		echo "\"$TEST\" has no \"$dir/dumps/$base.{nft,nodump}\" file"
+		EXIT_CODE=1
+	elif [ "$has_nft" == 1 -a "$has_nodump" == 1 ] ; then
+		echo "\"$TEST\" has both \"$dir/dumps/$base.{nft,nodump}\" files"
+		EXIT_CODE=1
+	elif [ "$has_nodump" == 1 -a -s "$nodump_name" ] ; then
+		echo "\"$TEST\" has a non-empty \"$dir/dumps/$base.nodump\" file"
+		EXIT_CODE=1
+	fi
+}
+
+SHELL_TESTS=( $(find "tests/shell/testcases/" -type f -executable | LANG=C sort) )
+
+if [ "${#SHELL_TESTS[@]}" -eq 0 ] ; then
+	echo "No executable tests under \"tests/shell/testcases/\" found"
+	EXIT_CODE=1
+fi
+for t in "${SHELL_TESTS[@]}" ; do
+	check_shell_dumps "$t"
+done
+
+##############################################################################
+
+SHELL_TESTS2=( $(./tests/shell/run-tests.sh --list-tests) )
+if [ "${SHELL_TESTS[*]}" != "${SHELL_TESTS2[*]}" ] ; then
+	echo "\`./tests/shell/run-tests.sh --list-tests\` does not list the expected tests"
+	EXIT_CODE=1
+fi
+
+##############################################################################
+
+FILES=( $(find "tests/shell/testcases/" -type f | sed -n 's#\(tests/shell/testcases\(/.*\)\?/\)dumps/\(.*\)\.\(nft\|nodump\)$#\0#p' | LANG=C sort) )
+
+for f in "${FILES[@]}" ; do
+	f2="$(echo "$f" | sed -n 's#\(tests/shell/testcases\(/.*\)\?/\)dumps/\(.*\)\.\(nft\|nodump\)$#\1\3#p')"
+	if ! array_contains "$f2" "${SHELL_TESTS[@]}" ; then
+		echo "\"$f\" has no test \"$f2\""
+		EXIT_CODE=1
+	fi
+done
+
+##############################################################################
+
+exit "$EXIT_CODE"
-- 
2.41.0




[Index of Archives]     [Netfitler Users]     [Berkeley Packet Filter]     [LARTC]     [Bugtraq]     [Yosemite Forum]

  Powered by Linux